include \asm\win32.inc

include gethandle.inc
include getprocess.inc
include getprocessmem.inc
include start.inc

finditem PROTO STDCALL hwnd:DWORD,hprocess:DWORD,hprocessmem:DWORD,buff:DWORD
restore  PROTO STDCALL hwnd:DWORD,hprocess:DWORD,hprocessmem:DWORD,index:DWORD,x:DWORD,y:DWORD

.code

loaddata proc uses edi  ;return EAX=buffer else 0
  LOCAL hkey:DWORD,count:DWORD
 ;initialise the return value to NOPE
  sub edi,edi
 ;try to open our registry key
  INVOKE RegOpenKeyEx,HKCU,OFFSET subkey,0,KEY_ALL_ACCESS,ADDR hkey
  jeaxnz done
 ;now try to get the length of the value we want (if it exists)
  INVOKE RegQueryValueEx,hkey,OFFSET value,0,0,0,ADDR count
  jeaxnz fini
 ;if it's empty, then there's nothing to do
  cmp count,eax
  jz fini
 ;allocate some memory to read the value into
  INVOKE VirtualAlloc,0,count,MEM_COMMIT,PAGE_READWRITE
  jeaxz fini
  mov edi,eax
 ;now actually read the value
  INVOKE RegQueryValueEx,hkey,OFFSET value,0,0,edi,ADDR count
  jeaxz fini
 ;reading failed, so deallocate the memory
  INVOKE VirtualFree,edi,0,MEM_RELEASE
  sub edi,edi
 fini:
  INVOKE RegCloseKey,hkey
 done:
  mov eax,edi
  ret
loaddata endp

finditem PROC USES EBX ESI EDI hwnd:DWORD,hprocess:DWORD,hprocessmem:DWORD,buff:DWORD
    LOCAL item:LVFINDINFO
      INVOKE RtlZeroMemory,ADDR item,SIZEOF item
      mov esi,hprocessmem
      mov ebx,hprocess
      lea edi,[esi+SIZEOF item]

      push LVFI_STRING
      pop item.flags
      mov item.psz,edi

      INVOKE WriteProcessMemory,ebx,esi,ADDR item,SIZEOF item,0
      INVOKE lstrlen,buff
      inc eax
      INVOKE WriteProcessMemory,ebx,edi,buff,eax,0
      INVOKE SendMessage,hwnd,LVM_FINDITEM,-1,esi
      ret
finditem endp

restore PROC USES EBX ESI EDI hwnd:DWORD,hprocess:DWORD,hprocessmem:DWORD,index:DWORD,x:DWORD,y:DWORD
      INVOKE WriteProcessMemory,hprocess,hprocessmem,ADDR x,SIZEOF POINT,0
      INVOKE SendMessage,hwnd,LVM_SETITEMPOSITION32,index,hprocessmem
      ret
restore ENDP

main PROC PRIVATE USES EBX EDX ESI EDI hwnd:DWORD,hprocess:DWORD,hprocessmem:DWORD
      call loaddata
      jeaxz done
      mov ebx,eax		;hlocalmem
      mov esi,4
      mov edi,[ebx]
 next:lea eax,[ebx+esi+SIZEOF POINT]
      INVOKE finditem,hwnd,hprocess,hprocessmem,eax
      cmp eax,-1
      jz skip
      lea edx,[ebx+esi]
      INVOKE restore,hwnd,hprocess,hprocessmem,eax,[edx],[edx+4]
 skip:lea eax,[ebx+esi+SIZEOF POINT]
      INVOKE lstrlen,eax
      lea esi,[esi+SIZEOF POINT+eax+1]
      dec edi
      jnz next
 done:ret
main ENDP
end start
