include \asm\win32.inc

include gethandle.inc
include getprocess.inc
include getprocessmem.inc
include start.inc

gettext PROTO STDCALL hwnd:DWORD,hprocess:DWORD,hprocessmem:DWORD,upto:DWORD,buff:DWORD
getpos  PROTO STDCALL hwnd:DWORD,hprocess:DWORD,hprocessmem:DWORD,upto:DWORD,buff:DWORD

.code


gettext PROC USES EBX ESI EDI hwnd:DWORD,hprocess:DWORD,hprocessmem:DWORD,upto:DWORD,buff:DWORD
    LOCAL item:LVITEM

    INVOKE RtlZeroMemory,ADDR item,SIZEOF item
    mov esi,hprocessmem
    mov ebx,hprocess

    lea eax,[esi+SIZEOF item]
    push 1
    pop item._mask
    push upto
    pop item.iItem
    mov item.pszText,eax
    push 260
    pop item.cchTextMax

    INVOKE WriteProcessMemory,ebx,esi,ADDR item,SIZEOF item,0
    INVOKE SendMessage,hwnd,LVM_GETITEMTEXT,upto,esi
    mov edi,eax
    INVOKE ReadProcessMemory,ebx,item.pszText,buff,eax,0
    mov eax,edi
    ret
gettext endp

getpos PROC hwnd:DWORD,hprocess:DWORD,hprocessmem:DWORD,upto:DWORD,buff:DWORD
    INVOKE SendMessage,hwnd,LVM_GETITEMPOSITION,upto,hprocessmem
    INVOKE ReadProcessMemory,hprocess,hprocessmem,buff,SIZEOF POINT,0
    ret
getpos endp

main PROC PRIVATE USES EBX ESI EDI hwnd:DWORD,hprocess:DWORD,hprocessmem:DWORD
  LOCAL upto:DWORD
      sub esi,esi
      INVOKE SendMessage,hwnd,LVM_GETITEMCOUNT,esi,esi
      jeaxz done
      mov ebx,eax		;count

      shl eax,3
      mov edi,eax
      shl eax,8
      mov upto,esi
      add eax,edi
      INVOKE VirtualAlloc,esi,eax,MEM_COMMIT,PAGE_READWRITE
      jeaxz done
      mov esi,eax		;localmem

      mov edi,4			;buffoffset
      mov [esi],ebx

 next:lea eax,[esi+edi]
      INVOKE getpos,hwnd,hprocess,hprocessmem,upto,eax
      lea eax,[esi+edi+SIZEOF POINT]
      INVOKE gettext,hwnd,hprocess,hprocessmem,upto,eax
      lea edi,[edi+SIZEOF POINT+eax+1]
      inc upto
      dec ebx
      jnz next

      INVOKE RegCreateKeyEx,HKCU,OFFSET subkey,ebx,ebx,REG_OPTION_NON_VOLATILE,
                            KEY_ALL_ACCESS,ebx,ADDR upto,ebx
      jeaxnz oops
      INVOKE RegSetValueEx,upto,OFFSET value,0,REG_BINARY,esi,edi
      jeaxnz oops
      INVOKE RegCloseKey,upto
      jmp done
 oops:sub eax,eax
 done:ret
main ENDP
end start
